# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Hdinsight::Mgmt::V2018_06_01_preview
  module Models
    #
    # The HDInsight cluster application GET response.
    #
    class ApplicationProperties

      include MsRestAzure

      # @return [ComputeProfile] The list of roles in the cluster.
      attr_accessor :compute_profile

      # @return [Array<RuntimeScriptAction>] The list of install script
      # actions.
      attr_accessor :install_script_actions

      # @return [Array<RuntimeScriptAction>] The list of uninstall script
      # actions.
      attr_accessor :uninstall_script_actions

      # @return [Array<ApplicationGetHttpsEndpoint>] The list of application
      # HTTPS endpoints.
      attr_accessor :https_endpoints

      # @return [Array<ApplicationGetEndpoint>] The list of application SSH
      # endpoints.
      attr_accessor :ssh_endpoints

      # @return [String] The provisioning state of the application.
      attr_accessor :provisioning_state

      # @return [String] The application type.
      attr_accessor :application_type

      # @return [String] The application state.
      attr_accessor :application_state

      # @return [Array<Errors>] The list of errors.
      attr_accessor :errors

      # @return [String] The application create date time.
      attr_accessor :created_date

      # @return [String] The marketplace identifier.
      attr_accessor :marketplace_identifier


      #
      # Mapper for ApplicationProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ApplicationProperties',
          type: {
            name: 'Composite',
            class_name: 'ApplicationProperties',
            model_properties: {
              compute_profile: {
                client_side_validation: true,
                required: false,
                serialized_name: 'computeProfile',
                type: {
                  name: 'Composite',
                  class_name: 'ComputeProfile'
                }
              },
              install_script_actions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'installScriptActions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'RuntimeScriptActionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'RuntimeScriptAction'
                      }
                  }
                }
              },
              uninstall_script_actions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'uninstallScriptActions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'RuntimeScriptActionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'RuntimeScriptAction'
                      }
                  }
                }
              },
              https_endpoints: {
                client_side_validation: true,
                required: false,
                serialized_name: 'httpsEndpoints',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ApplicationGetHttpsEndpointElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ApplicationGetHttpsEndpoint'
                      }
                  }
                }
              },
              ssh_endpoints: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sshEndpoints',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ApplicationGetEndpointElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ApplicationGetEndpoint'
                      }
                  }
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'provisioningState',
                type: {
                  name: 'String'
                }
              },
              application_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'applicationType',
                type: {
                  name: 'String'
                }
              },
              application_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'applicationState',
                type: {
                  name: 'String'
                }
              },
              errors: {
                client_side_validation: true,
                required: false,
                serialized_name: 'errors',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ErrorsElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Errors'
                      }
                  }
                }
              },
              created_date: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'createdDate',
                type: {
                  name: 'String'
                }
              },
              marketplace_identifier: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'marketplaceIdentifier',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
